//+------------------------------------------------------------------+
//|                                                     Kuklovod.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
   
  extern int StartLevel      = 10;
  extern int StopLevel       = 30;
  extern int TakeProfitLevel = 70;
  extern int StopLossLevel   = 10;
  extern int TakeProfit         = 0;
  extern int StopLoss           = 0;
  extern double Lot             = 0.01;
  extern int Slippage           = 50;
  extern int Magic              = 4700;
  extern double StartBalance    = 0;
  extern bool OnIndicatorWithTp = true;
  extern bool OnIndicatorWithSl = true;
  extern bool ShowInfo          = true;
  extern bool USDCAD            = true;
  extern bool USDCHF            = false;
  extern bool USDJPY            = false;
  extern bool EURUSD            = false;
  extern bool GBPUSD            = false;
  extern bool AUDUSD            = false;
  extern bool NZDUSD            = false;
  extern color TextColor        = Yellow;
  extern bool Protect           = true;
  extern int  Prosadka          = 10;
  
  int tp, sl, slip, count, countbuy, countsell;
  double ind;
  int  magic[4];
  bool USDBuy = false, SellUSD = false, USDSell = false, BuyUSD = false,
       USDSellSl = false, BuyUSDSl = false, USDBuySl = false, SellUSDSl = false,
       USDBuyTp = false, SellUSDTp = false, USDSellTp = false, BuyUSDTp = false;
  bool SignalProtection   = false;
  double profit,profitall, BalanceMax, PercentProsadka, usdprosadka;
  double USDCADAsk, USDCADBid, USDCHFAsk, USDCHFBid, USDJPYAsk, USDJPYBid, EURUSDAsk,
         EURUSDBid, GBPUSDAsk, GBPUSDBid, AUDUSDAsk, AUDUSDBid, NZDUSDAsk, NZDUSDBid;
  double usdcaddigits, usdchfdigits, usdjpydigits, eurusddigits, gbpusddigits, audusddigits, nzdusddigits;
  
  void init(){
   if (Digits == 3 || Digits == 5){slip = Slippage*10;}
   if (Digits == 2 || Digits == 4){slip = Slippage;}
//----
   if (TakeProfit > 0 ){
     if (Digits == 3 || Digits == 5){tp = TakeProfit*10;}
     if (Digits == 2 || Digits == 4){tp = TakeProfit;}   
   }
   if (TakeProfit == 0){tp = 0;}
//----
   if (StopLoss > 0 ){
     if (Digits == 3 || Digits == 5){sl = StopLoss*10;}
     if (Digits == 2 || Digits == 4){sl = StopLoss;}
   }
   if (StopLoss == 0){sl = 0;}
//----
   if (StartBalance == 0){StartBalance = AccountBalance();}
    magic[0] = Magic+12;   //USD/xxx - Buy
    magic[1] = Magic+21;   //xxx/USD - Sell
    magic[2] = Magic+34;   //USD/xxx - Sell
    magic[3] = Magic+43;   //xxx/USD - Buy
//---
   usdcaddigits = MarketInfo("USDCAD",MODE_DIGITS);
   usdchfdigits = MarketInfo("USDCHF",MODE_DIGITS);
   usdjpydigits = MarketInfo("USDJPY",MODE_DIGITS);
   eurusddigits = MarketInfo("EURUSD",MODE_DIGITS);
   gbpusddigits = MarketInfo("GBPUSD",MODE_DIGITS);
   audusddigits = MarketInfo("AUDUSD",MODE_DIGITS);
   nzdusddigits = MarketInfo("NZDUSD",MODE_DIGITS);
  
  }
  void deinit(){
    ObjectDel("Com",3);
  }
  void start(){
     if (Protect){Protection();}
     if (!SignalProtection){Signal();}
     CountOrders();
     CloseOrders();
     Profit();
     if (ShowInfo){Text();}
     /*Comment("ind = ",DoubleToStr(ind,2),"\n",
             "count = ",count,"\n",
             "countbuy = ",countbuy,"\n",
             "countsell = ",countsell,"\n",
             "USDBuy = ",USDBuy,"\n",
             "SellUSD = ",SellUSD,"\n",
             "USDSell = ",USDSell,"\n",
             "BuyUSD = ",BuyUSD,"\n",
             "USDSellSl = ", USDSellSl,"\n",
             "BuyUSDSl = ",BuyUSDSl,"\n", 
             "USDBuySl = ",USDBuySl,"\n", 
             "SellUSDSl = ",SellUSDSl,"\n",
             "USDBuyTp = ",USDBuyTp,"\n", 
             "SellUSDTp = ",SellUSDTp,"\n",
             "USDSellTp = ",USDSellTp,"\n", 
             "BuyUSDTp = ",BuyUSDTp);*/
     Comment("USDCADAsk = ",USDCADAsk,"\n",
             "USDCADBid  = ",USDCADBid,"\n",
             "USDCHFAsk = ",USDCHFAsk,"\n",
             "USDCHFBid  = ",USDCHFBid,"\n",
             "USDJPYAsk = ",USDJPYAsk,"\n",
             "USDJPYBid  = ",USDJPYBid,"\n",
             "EURUSDAsk = ",EURUSDAsk,"\n",
             "EURUSDBid  = ",EURUSDBid,"\n",
             "GBPUSDAsk = ",GBPUSDAsk,"\n",
             "GBPUSDBid  = ",GBPUSDBid,"\n",
             "AUDUSDAsk = ",AUDUSDAsk,"\n",
             "AUDUSDBid  = ",AUDUSDBid,"\n",
             "NZDUSDAsk = ",NZDUSDAsk,"\n",
             "NZDUSDBid  = ",NZDUSDBid,"\n");
     USDCADAsk = DoubleToString(MarketInfo("USDCAD",MODE_ASK),usdcaddigits);            
     USDCADBid = DoubleToString(MarketInfo("USDCAD",MODE_BID),usdcaddigits);
     USDCHFAsk = DoubleToString(MarketInfo("USDCHF",MODE_ASK),usdchfdigits);
     USDCHFBid = DoubleToString(MarketInfo("USDCHF",MODE_BID),usdchfdigits);
     USDJPYAsk = DoubleToString(MarketInfo("USDJPY",MODE_ASK),usdjpydigits);
     USDJPYBid = DoubleToString(MarketInfo("USDJPY",MODE_BID),usdjpydigits);
     EURUSDAsk = DoubleToString(MarketInfo("EURUSD",MODE_ASK),eurusddigits);
     EURUSDBid = DoubleToString(MarketInfo("EURUSD",MODE_BID),eurusddigits);
     GBPUSDAsk = DoubleToString(MarketInfo("GBPUSD",MODE_ASK),gbpusddigits);
     GBPUSDBid = DoubleToString(MarketInfo("GBPUSD",MODE_BID),gbpusddigits);
     AUDUSDAsk = DoubleToString(MarketInfo("AUDUSD",MODE_ASK),audusddigits);
     AUDUSDBid = DoubleToString(MarketInfo("AUDUSD",MODE_BID),audusddigits);
     NZDUSDAsk = DoubleToString(MarketInfo("NZDUSD",MODE_ASK),nzdusddigits);
     NZDUSDBid = DoubleToString(MarketInfo("NZDUSD",MODE_BID),nzdusddigits);             
             
     
  }
//+------------------------------------------------------------------+
   void Profit(){
     profit = 0;
     for (int i = OrdersHistoryTotal()-1; i >= 0; i--){
        if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) == true){
          if (OrderSymbol() == Symbol() || OrderMagicNumber() ==  magic[0] || OrderMagicNumber() ==   magic[1] || OrderMagicNumber() ==   magic[2] || OrderMagicNumber() ==   magic[3]){
            profit = profit + OrderProfit() + OrderCommission() + OrderSwap();
          }
       }
     }
     for (int i = OrdersTotal()-1; i >= 0; i--){
        if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) == true){
           if (OrderSymbol() == Symbol() || OrderMagicNumber() ==  magic[0] || OrderMagicNumber() ==   magic[1] || OrderMagicNumber() ==   magic[2] || OrderMagicNumber() ==   magic[3]){
           
           }
        }
     }   
  }
//+------------------------------------------------------------------+
  void Protection(){
    if(AccountBalance()>BalanceMax){BalanceMax=AccountBalance();}  
    PercentProsadka =((BalanceMax-AccountBalance())*100/BalanceMax);
    usdprosadka = BalanceMax - AccountBalance();
    if(PercentProsadka>Prosadka){SignalProtection=true;}
  }
//+------------------------------------------------------------------+
  void Signal(){
     ind = iCustom(NULL,PERIOD_D1,"Kuklovod_USD",7,0);
     //-----
     //if (Hour() == 0){      
        if (ind > StartLevel && ind < StopLevel)  {SellUSD = true; USDBuy = true;  Call();}
           else if (ind < StartLevel || ind > StopLevel){USDBuy = false; SellUSD = false;}
        if (ind < -StartLevel && ind > -StopLevel){USDSell = true; BuyUSD = true; Call();}
           else if (ind > -StartLevel || ind < -StopLevel){USDSell = false; BuyUSD = false;}
     //-----  
        if (StopLoss == 0){   
           if (ind > StopLossLevel) {USDSellSl = true; BuyUSDSl = true;}
              else if(ind < StopLossLevel){USDSellSl = false; BuyUSDSl = false;}
           if (ind < -StopLossLevel){USDBuySl = true; SellUSDSl = true;}
              else if(ind > -StopLossLevel){USDBuySl = false; SellUSDSl = false;}
        }
        if (StopLoss > 0 && OnIndicatorWithSl == true){
           if (ind > StopLossLevel) {USDSellSl = true; BuyUSDSl = true;}
              else if(ind < StopLossLevel){USDSellSl = false; BuyUSDSl = false;}
           if (ind < -StopLossLevel){USDBuySl = true; SellUSDSl = true;}
              else if(ind > -StopLossLevel){USDBuySl = false; SellUSDSl = false;}
        }
        if (StopLoss > 0 && OnIndicatorWithSl == false){
           USDSellSl = false; BuyUSDSl = false;
           USDBuySl = false; SellUSDSl = false;
        }
     //}
//---------
     if (TakeProfit == 0){
        if (ind > TakeProfitLevel) {USDBuyTp = true; SellUSDTp = true;}
           else if( ind < TakeProfitLevel){USDBuyTp  = false; SellUSDTp = false;}
        if (ind < -TakeProfitLevel){USDSellTp = true; BuyUSDTp = true;}
           else if(ind > -TakeProfitLevel){USDSellTp = false; BuyUSDTp = false;}
     }
     if (TakeProfit > 0 && OnIndicatorWithTp == true){
        if (ind > TakeProfitLevel) {USDBuyTp = true; SellUSDTp = true;}
           else if( ind < TakeProfitLevel){USDBuyTp  = false; SellUSDTp = false;}
        if (ind < -TakeProfitLevel){USDSellTp = true; BuyUSDTp = true;}
           else if(ind > -TakeProfitLevel){USDSellTp = false; BuyUSDTp = false;}
     }
     if (TakeProfit > 0 && OnIndicatorWithTp == false){
        USDBuyTp  = false; SellUSDTp = false;
        USDSellTp = false; BuyUSDTp = false;
     }

  }
//+------------------------------------------------------------------+
   void OpenOrders_TP_SL(){
     int Result[14];
//---     
     if (USDBuy && countbuy == 0){
        if (USDCAD){while(IsTradeContextBusy()){Sleep(10);}
                    RefreshRates();
                    Result[0] = OrderSend("USDCAD",OP_BUY,Lot,USDCADAsk,slip,USDCADAsk-NormalizeDouble(sl*Point,Digits),USDCADAsk+NormalizeDouble(tp*Point,Digits),"USDCAD",magic[0],0,Red);
                    if (Result[0] < 0){Alert(" OpenOrders ","\n","  "+"USDCAD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
        if (USDCHF){while(IsTradeContextBusy()){Sleep(10);}
                    RefreshRates();
                    Result[1] = OrderSend("USDCHF",OP_BUY,Lot,USDCHFAsk,slip,USDCHFAsk-NormalizeDouble(sl*Point,Digits),USDCHFAsk+NormalizeDouble(tp*Point,Digits),"USDCHF",magic[0],0,Red);
                    if (Result[1] < 0){Alert(" OpenOrders ","\n","  "+"USDCHF","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
        if (USDJPY){while(IsTradeContextBusy()){Sleep(10);}
                    RefreshRates();
                    Result[2] = OrderSend("USDJPY",OP_BUY,Lot,USDJPYAsk,slip,USDJPYAsk-NormalizeDouble(sl*Point,Digits),USDJPYAsk+NormalizeDouble(tp*Point,Digits),"USDJPY",magic[0],0,Red);
                    if (Result[2] < 0){Alert(" OpenOrders ","\n","  "+"USDJPY","\n", 
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
     }
//---
     if (SellUSD && countsell == 0){
       if (EURUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[3] = OrderSend("EURUSD",OP_SELL,Lot,EURUSDBid,slip,EURUSDBid+NormalizeDouble(sl*Point,Digits),EURUSDBid-NormalizeDouble(tp*Point,Digits),"EURUSD",magic[1],0,Blue);
                   if (Result[3] < 0){Alert(" OpenOrders ","\n","  "+"EURUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (GBPUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[4] = OrderSend("GBPUSD",OP_SELL,Lot,GBPUSDBid,slip,GBPUSDBid+NormalizeDouble(sl*Point,Digits),GBPUSDBid-NormalizeDouble(tp*Point,Digits),"GBPUSD",magic[1],0,Blue);
                   if (Result[4] < 0){Alert(" OpenOrders ","\n","  "+"GBPUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (AUDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[5] = OrderSend("AUDUSD",OP_SELL,Lot,AUDUSDBid,slip,AUDUSDBid+NormalizeDouble(sl*Point,Digits),AUDUSDBid-NormalizeDouble(tp*Point,Digits),"AUDUSD",magic[1],0,Blue);
                   if (Result[5] < 0){Alert(" OpenOrders ","\n","  "+"AUDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (NZDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[6] = OrderSend("NZDUSD",OP_SELL,Lot,NZDUSDBid,slip,NZDUSDBid+NormalizeDouble(sl*Point,Digits),NZDUSDBid-NormalizeDouble(tp*Point,Digits),"NZDUSD",magic[1],0,Blue);
                   if (Result[6] < 0){Alert(" OpenOrders ","\n","  "+"NZDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
     
     }
//---
     if (USDSell && countsell == 0){
       if (USDCAD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[7] = OrderSend("USDCAD",OP_SELL,Lot,USDCADBid,slip,USDCADBid+NormalizeDouble(sl*Point,Digits),USDCADBid-NormalizeDouble(tp*Point,Digits),"USDCAD",magic[2],0,Blue);
                   if (Result[7] < 0){Alert(" OpenOrders ","\n","  "+"USDCAD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (USDCHF){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[8] = OrderSend("USDCHF",OP_SELL,Lot,USDCHFBid,slip,USDCHFBid+NormalizeDouble(sl*Point,Digits),USDCHFBid-NormalizeDouble(tp*Point,Digits),"USDCHF",magic[2],0,Blue);
                   if (Result[8] < 0){Alert(" OpenOrders ","\n","  "+"USDCHF","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (USDJPY){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[9] = OrderSend("USDJPY",OP_SELL,Lot,USDJPYBid,slip,USDJPYBid+NormalizeDouble(sl*Point,Digits),USDJPYBid-NormalizeDouble(tp*Point,Digits),"USDJPY",magic[2],0,Blue);
                   if (Result[9] < 0){Alert(" OpenOrders ","\n","  "+"USDJPY","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
    }
//---
     if (BuyUSD && countbuy == 0){
       if (EURUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[10] = OrderSend("EURUSD",OP_BUY,Lot,EURUSDAsk,slip,EURUSDAsk-NormalizeDouble(sl*Point,Digits),EURUSDAsk+NormalizeDouble(tp*Point,Digits),"EURUSD",magic[3],0,Red);
                   if (Result[10] < 0){Alert(" OpenOrders ","\n","  "+"EURUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (GBPUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[11] = OrderSend("GBPUSD",OP_BUY,Lot,GBPUSDAsk,slip,GBPUSDAsk-NormalizeDouble(sl*Point,Digits),GBPUSDAsk+NormalizeDouble(tp*Point,Digits),"GBPUSD",magic[3],0,Red);
                   if (Result[11] < 0){Alert(" OpenOrders ","\n","  "+"GBPUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (AUDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();   
                   Result[12] = OrderSend("AUDUSD",OP_BUY,Lot,AUDUSDAsk,slip,AUDUSDAsk-NormalizeDouble(sl*Point,Digits),AUDUSDAsk+NormalizeDouble(tp*Point,Digits),"AUDUSD",magic[3],0,Red);
                   if (Result[12] < 0){Alert(" OpenOrders ","\n","  "+"AUDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (NZDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[13] = OrderSend("NZDUSD",OP_BUY,Lot,NZDUSDAsk,slip,NZDUSDAsk-NormalizeDouble(sl*Point,Digits),NZDUSDAsk+NormalizeDouble(tp*Point,Digits),"NZDUSD",magic[3],0,Red);
                   if (Result[13] < 0){Alert(" OpenOrders ","\n","  "+"NZDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
    }
   }
//+------------------------------------------------------------------+
   void OpenOrders(){
     int Result[14];
//---     
     if (USDBuy && countbuy == 0){
        if (USDCAD){while(IsTradeContextBusy()){Sleep(10);}
                    RefreshRates();
                    Result[0] = OrderSend("USDCAD",OP_BUY,Lot,USDCADAsk,slip,0,0,"USDCAD",magic[0],0,Red);
                    if (Result[0] < 0){Alert(" OpenOrders ","\n","  "+"USDCAD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
        if (USDCHF){while(IsTradeContextBusy()){Sleep(10);}
                    RefreshRates();
                    Result[1] = OrderSend("USDCHF",OP_BUY,Lot,USDCHFAsk,slip,0,0,"USDCHF",magic[0],0,Red);
                    if (Result[1] < 0){Alert(" OpenOrders ","\n","  "+"USDCHF","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
        if (USDJPY){while(IsTradeContextBusy()){Sleep(10);}
                    RefreshRates();
                    Result[2] = OrderSend("USDJPY",OP_BUY,Lot,USDJPYAsk,slip,0,0,"USDJPY",magic[0],0,Red);
                    if (Result[2] < 0){Alert(" OpenOrders ","\n","  "+"USDJPY","\n", 
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
     }
//---
     if (SellUSD && countsell == 0){
       if (EURUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[3] = OrderSend("EURUSD",OP_SELL,Lot,EURUSDBid,slip,0,0,"EURUSD",magic[1],0,Blue);
                   if (Result[3] < 0){Alert(" OpenOrders ","\n","  "+"EURUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (GBPUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[4] = OrderSend("GBPUSD",OP_SELL,Lot,GBPUSDBid,slip,0,0,"GBPUSD",magic[1],0,Blue);
                   if (Result[4] < 0){Alert(" OpenOrders ","\n","  "+"GBPUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (AUDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[5] = OrderSend("AUDUSD",OP_SELL,Lot,AUDUSDBid,slip,0,0,"AUDUSD",magic[1],0,Blue);
                   if (Result[5] < 0){Alert(" OpenOrders ","\n","  "+"AUDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (NZDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[6] = OrderSend("NZDUSD",OP_SELL,Lot,NZDUSDBid,slip,0,0,"NZDUSD",magic[1],0,Blue);
                   if (Result[6] < 0){Alert(" OpenOrders ","\n","  "+"NZDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
     
     }
//---
     if (USDSell && countsell == 0){
       if (USDCAD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[7] = OrderSend("USDCAD",OP_SELL,Lot,USDCADBid,slip,0,0,"USDCAD",magic[2],0,Blue);
                   if (Result[7] < 0){Alert(" OpenOrders ","\n","  "+"USDCAD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (USDCHF){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[8] = OrderSend("USDCHF",OP_SELL,Lot,USDCHFBid,slip,0,0,"USDCHF",magic[2],0,Blue);
                   if (Result[8] < 0){Alert(" OpenOrders ","\n","  "+"USDCHF","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (USDJPY){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[9] = OrderSend("USDJPY",OP_SELL,Lot,USDJPYBid,slip,0,0,"USDJPY",magic[2],0,Blue);
                   if (Result[9] < 0){Alert(" OpenOrders ","\n","  "+"USDJPY","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
    }
//---
     if (BuyUSD && countbuy == 0){
       if (EURUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[10] = OrderSend("EURUSD",OP_BUY,Lot,EURUSDAsk,slip,0,0,"EURUSD",magic[3],0,Red);
                   if (Result[10] < 0){Alert(" OpenOrders ","\n","  "+"EURUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (GBPUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[11] = OrderSend("GBPUSD",OP_BUY,Lot,GBPUSDAsk,slip,0,0,"GBPUSD",magic[3],0,Red);
                   if (Result[11] < 0){Alert(" OpenOrders ","\n","  "+"GBPUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (AUDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();   
                   Result[12] = OrderSend("AUDUSD",OP_BUY,Lot,AUDUSDAsk,slip,0,0,"AUDUSD",magic[3],0,Red);
                   if (Result[12] < 0){Alert(" OpenOrders ","\n","  "+"AUDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (NZDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[13] = OrderSend("NZDUSD",OP_BUY,Lot,NZDUSDAsk,slip,0,0,"NZDUSD",magic[3],0,Red);
                   if (Result[13] < 0){Alert(" OpenOrders ","\n","  "+"NZDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
    }
   }
//+------------------------------------------------------------------+
   void OpenOrders_SL(){
     int Result[14];
//---     
     if (USDBuy && countbuy == 0){
        if (USDCAD){while(IsTradeContextBusy()){Sleep(10);}
                    RefreshRates();
                    Result[0] = OrderSend("USDCAD",OP_BUY,Lot,USDCADAsk,slip,USDCADAsk-NormalizeDouble(sl*Point,Digits),0,"USDCAD",magic[0],0,Red);
                    if (Result[0] < 0){Alert(" OpenOrders ","\n","  "+"USDCAD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
        if (USDCHF){while(IsTradeContextBusy()){Sleep(10);}
                    RefreshRates();
                    Result[1] = OrderSend("USDCHF",OP_BUY,Lot,USDCHFAsk,slip,USDCHFAsk-NormalizeDouble(sl*Point,Digits),0,"USDCHF",magic[0],0,Red);
                    if (Result[1] < 0){Alert(" OpenOrders ","\n","  "+"USDCHF","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
        if (USDJPY){while(IsTradeContextBusy()){Sleep(10);}
                    RefreshRates();
                    Result[2] = OrderSend("USDJPY",OP_BUY,Lot,USDJPYAsk,slip,USDJPYAsk-NormalizeDouble(sl*Point,Digits),0,"USDJPY",magic[0],0,Red);
                    if (Result[2] < 0){Alert(" OpenOrders ","\n","  "+"USDJPY","\n", 
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
     }
//---
     if (SellUSD && countsell == 0){
       if (EURUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[3] = OrderSend("EURUSD",OP_SELL,Lot,EURUSDBid,slip,EURUSDBid+NormalizeDouble(sl*Point,Digits),0,"EURUSD",magic[1],0,Blue);
                   if (Result[3] < 0){Alert(" OpenOrders ","\n","  "+"EURUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (GBPUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[4] = OrderSend("GBPUSD",OP_SELL,Lot,GBPUSDBid,slip,GBPUSDBid+NormalizeDouble(sl*Point,Digits),0,"GBPUSD",magic[1],0,Blue);
                   if (Result[4] < 0){Alert(" OpenOrders ","\n","  "+"GBPUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (AUDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[5] = OrderSend("AUDUSD",OP_SELL,Lot,AUDUSDBid,slip,AUDUSDBid+NormalizeDouble(sl*Point,Digits),0,"AUDUSD",magic[1],0,Blue);
                   if (Result[5] < 0){Alert(" OpenOrders ","\n","  "+"AUDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (NZDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[6] = OrderSend("NZDUSD",OP_SELL,Lot,NZDUSDBid,slip,NZDUSDBid+NormalizeDouble(sl*Point,Digits),0,"NZDUSD",magic[1],0,Blue);
                   if (Result[6] < 0){Alert(" OpenOrders ","\n","  "+"NZDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
     
     }
//---
     if (USDSell && countsell == 0){
       if (USDCAD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[7] = OrderSend("USDCAD",OP_SELL,Lot,USDCADBid,slip,USDCADBid+NormalizeDouble(sl*Point,Digits),0,"USDCAD",magic[2],0,Blue);
                   if (Result[7] < 0){Alert(" OpenOrders ","\n","  "+"USDCAD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (USDCHF){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[8] = OrderSend("USDCHF",OP_SELL,Lot,USDCHFBid,slip,USDCHFBid+NormalizeDouble(sl*Point,Digits),0,"USDCHF",magic[2],0,Blue);
                   if (Result[8] < 0){Alert(" OpenOrders ","\n","  "+"USDCHF","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (USDJPY){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[9] = OrderSend("USDJPY",OP_SELL,Lot,USDJPYBid,slip,USDJPYBid+NormalizeDouble(sl*Point,Digits),0,"USDJPY",magic[2],0,Blue);
                   if (Result[9] < 0){Alert(" OpenOrders ","\n","  "+"USDJPY","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
    }
//---
     if (BuyUSD && countbuy == 0){
       if (EURUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[10] = OrderSend("EURUSD",OP_BUY,Lot,EURUSDAsk,slip,EURUSDAsk-NormalizeDouble(sl*Point,Digits),0,"EURUSD",magic[3],0,Red);
                   if (Result[10] < 0){Alert(" OpenOrders ","\n","  "+"EURUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (GBPUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[11] = OrderSend("GBPUSD",OP_BUY,Lot,GBPUSDAsk,slip,GBPUSDAsk-NormalizeDouble(sl*Point,Digits),0,"GBPUSD",magic[3],0,Red);
                   if (Result[11] < 0){Alert(" OpenOrders ","\n","  "+"GBPUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (AUDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();   
                   Result[12] = OrderSend("AUDUSD",OP_BUY,Lot,AUDUSDAsk,slip,AUDUSDAsk-NormalizeDouble(sl*Point,Digits),0,"AUDUSD",magic[3],0,Red);
                   if (Result[12] < 0){Alert(" OpenOrders ","\n","  "+"AUDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (NZDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[13] = OrderSend("NZDUSD",OP_BUY,Lot,NZDUSDAsk,slip,NZDUSDAsk-NormalizeDouble(sl*Point,Digits),0,"NZDUSD",magic[3],0,Red);
                   if (Result[13] < 0){Alert(" OpenOrders ","\n","  "+"NZDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
    }
   }
//+------------------------------------------------------------------+
   void OpenOrders_TP(){
     int Result[14];
//---     
     if (USDBuy && countbuy == 0){
        if (USDCAD){while(IsTradeContextBusy()){Sleep(10);}
                    RefreshRates();
                    Result[0] = OrderSend("USDCAD",OP_BUY,Lot,USDCADAsk,slip,0,USDCADAsk+NormalizeDouble(tp*Point,Digits),"USDCAD",magic[0],0,Red);
                    if (Result[0] < 0){Alert(" OpenOrders ","\n","  "+"USDCAD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
        if (USDCHF){while(IsTradeContextBusy()){Sleep(10);}
                    RefreshRates();
                    Result[1] = OrderSend("USDCHF",OP_BUY,Lot,USDCHFAsk,slip,0,USDCHFAsk+NormalizeDouble(tp*Point,Digits),"USDCHF",magic[0],0,Red);
                    if (Result[1] < 0){Alert(" OpenOrders ","\n","  "+"USDCHF","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
        if (USDJPY){while(IsTradeContextBusy()){Sleep(10);}
                    RefreshRates();
                    Result[2] = OrderSend("USDJPY",OP_BUY,Lot,USDJPYAsk,slip,0,USDJPYAsk+NormalizeDouble(tp*Point,Digits),"USDJPY",magic[0],0,Red);
                    if (Result[2] < 0){Alert(" OpenOrders ","\n","  "+"USDJPY","\n", 
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
     }
//---
     if (SellUSD && countsell == 0){
       if (EURUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[3] = OrderSend("EURUSD",OP_SELL,Lot,EURUSDBid,slip,0,EURUSDBid-NormalizeDouble(tp*Point,Digits),"EURUSD",magic[1],0,Blue);
                   if (Result[3] < 0){Alert(" OpenOrders ","\n","  "+"EURUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (GBPUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[4] = OrderSend("GBPUSD",OP_SELL,Lot,GBPUSDBid,slip,0,GBPUSDBid-NormalizeDouble(tp*Point,Digits),"GBPUSD",magic[1],0,Blue);
                   if (Result[4] < 0){Alert(" OpenOrders ","\n","  "+"GBPUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (AUDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[5] = OrderSend("AUDUSD",OP_SELL,Lot,AUDUSDBid,slip,0,AUDUSDBid-NormalizeDouble(tp*Point,Digits),"AUDUSD",magic[1],0,Blue);
                   if (Result[5] < 0){Alert(" OpenOrders ","\n","  "+"AUDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (NZDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[6] = OrderSend("NZDUSD",OP_SELL,Lot,NZDUSDBid,slip,0,NZDUSDBid-NormalizeDouble(tp*Point,Digits),"NZDUSD",magic[1],0,Blue);
                   if (Result[6] < 0){Alert(" OpenOrders ","\n","  "+"NZDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
     
     }
//---
     if (USDSell && countsell == 0){
       if (USDCAD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[7] = OrderSend("USDCAD",OP_SELL,Lot,USDCADBid,slip,0,USDCADBid-NormalizeDouble(tp*Point,Digits),"USDCAD",magic[2],0,Blue);
                   if (Result[7] < 0){Alert(" OpenOrders ","\n","  "+"USDCAD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (USDCHF){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[8] = OrderSend("USDCHF",OP_SELL,Lot,USDCHFBid,slip,0,USDCHFBid-NormalizeDouble(tp*Point,Digits),"USDCHF",magic[2],0,Blue);
                   if (Result[8] < 0){Alert(" OpenOrders ","\n","  "+"USDCHF","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (USDJPY){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[9] = OrderSend("USDJPY",OP_SELL,Lot,USDJPYBid,slip,0,USDJPYBid-NormalizeDouble(tp*Point,Digits),"USDJPY",magic[2],0,Blue);
                   if (Result[9] < 0){Alert(" OpenOrders ","\n","  "+"USDJPY","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
    }
//---
     if (BuyUSD && countbuy == 0){
       if (EURUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[10] = OrderSend("EURUSD",OP_BUY,Lot,EURUSDAsk,slip,0,EURUSDAsk+NormalizeDouble(tp*Point,Digits),"EURUSD",magic[3],0,Red);
                   if (Result[10] < 0){Alert(" OpenOrders ","\n","  "+"EURUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (GBPUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[11] = OrderSend("GBPUSD",OP_BUY,Lot,GBPUSDAsk,slip,0,GBPUSDAsk+NormalizeDouble(tp*Point,Digits),"GBPUSD",magic[3],0,Red);
                   if (Result[11] < 0){Alert(" OpenOrders ","\n","  "+"GBPUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (AUDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();   
                   Result[12] = OrderSend("AUDUSD",OP_BUY,Lot,AUDUSDAsk,slip,0,AUDUSDAsk+NormalizeDouble(tp*Point,Digits),"AUDUSD",magic[3],0,Red);
                   if (Result[12] < 0){Alert(" OpenOrders ","\n","  "+"AUDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
       if (NZDUSD){while(IsTradeContextBusy()){Sleep(10);}
                   RefreshRates();
                   Result[13] = OrderSend("NZDUSD",OP_BUY,Lot,NZDUSDAsk,slip,0,NZDUSDAsk+NormalizeDouble(tp*Point,Digits),"NZDUSD",magic[3],0,Red);
                   if (Result[13] < 0){Alert(" OpenOrders ","\n","  "+"NZDUSD","\n",
                    ":   Sell","\n", " : " ,errors(GetLastError()) );}}
    }
   }
//+------------------------------------------------------------------+
   void CountOrders(){
      count = 0;
      countbuy = 0;
      countsell= 0;
      for (int i = OrdersTotal()-1; i>=0; i--){
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
            if (OrderMagicNumber() == magic[0] || magic[1] || magic[2] || magic[3]) {count ++;
              if (OrderType() == OP_BUY) countbuy++;
              if (OrderType() == OP_SELL)countsell++;
            }
         }
      }
   }
//+------------------------------------------------------------------+
   void CloseOrders(){
      for (int i = OrdersTotal()-1; i>=0; i--){
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
             if (OrderMagicNumber() == magic[0]){
               if (USDBuySl || USDBuyTp){
                 while(IsTradeContextBusy()){Sleep(10);}
                 RefreshRates();
                 OrderClose(OrderTicket(),OrderLots(),Bid,slip,Blue);
               }
             }
             if (OrderMagicNumber() == magic[1]){
               if (SellUSDSl || SellUSDTp){
                 while(IsTradeContextBusy()){Sleep(10);}
                 RefreshRates();
                 OrderClose(OrderTicket(),OrderLots(),Ask,slip,Blue);
               }
             }
             if (OrderMagicNumber() == magic[2]){
               if (USDSellSl || USDSellTp){
                 while(IsTradeContextBusy()){Sleep(10);}
                 RefreshRates();
                 OrderClose(OrderTicket(),OrderLots(),Ask,slip,Blue);
               }
             }
             if (OrderMagicNumber() == magic[3]){
               if (BuyUSDSl || BuyUSDTp){
                 while(IsTradeContextBusy()){Sleep(10);}
                 RefreshRates();
                 OrderClose(OrderTicket(),OrderLots(),Bid,slip,Blue);
               }
             }      
         }
      }   
        
   }
//+------------------------------------------------------------------+
   void Text (){ 
  string Text[18];
  string Comments[18]={"Comment_1","Comment_2","Comment_3","Comment_4","Comment_5","Comment_6","Comment_7","Comment_8","Comment_9","Comment_10",
                       "Comment_11","Comment_12","Comment_13","Comment_14","Comment_15","Comment_16","Comment_17","Comment_18"};
    Text[0]  ="  = "+DoubleToStr(StartBalance,2);   
    Text[1]  ="  = "+DoubleToStr(BalanceMax,2);   
    Text[2]  ="  = "+DoubleToStr(AccountBalance(),2);
    Text[3]  ="  = "+DoubleToStr(profit,2)+"$";
    Text[4]  =" = "+DoubleToStr(PercentProsadka,2)+" %"; 
    Text[5]  ="           "+DoubleToStr(usdprosadka,2)+" $ ";    
    Text[6]  ="Take Profit = "+DoubleToStr(TakeProfit,0);
    Text[7]  ="Stop Loss = "+DoubleToStr(StopLoss,0);
    Text[8]  ="Lot =  "+DoubleToStr(Lot,2);   
    if (!SignalProtection) {Text[9]  =" ";} else Text[9] =" ";
  
    for(int i=0; i<=10; i++){
       
       if(ObjectFind(Comments[i])==-1){                                 
      
          ObjectCreate (Comments[i],OBJ_LABEL,0,0,0);  }                
          ObjectSet    (Comments[i],OBJPROP_CORNER, 1);                                                                           
          ObjectSet    (Comments[i],OBJPROP_XDISTANCE,20);             
          ObjectSet    (Comments[i],OBJPROP_YDISTANCE,30+i*15);         
         
       ObjectSetText(Comments[i],Text[i],10,"Times New Roman",Yellow);    
    } 
 }
//+------------------------------------------------------------------+
  void ObjectDel(string mask,int znk){//,  
    for(int i=ObjectsTotal()-1;i>=0;i--){  //           
        if (StringSubstr(ObjectName(i),0,znk)==mask){ObjectDelete(ObjectName(i));}
    }  
  }
//+------------------------------------------------------------------+
  void Call(){
    if (TakeProfit > 0 && StopLoss > 0)OpenOrders_TP_SL();
    if (TakeProfit > 0 && StopLoss == 0)OpenOrders_TP();
    if (TakeProfit == 0 && StopLoss > 0)OpenOrders_SL();
    if (TakeProfit == 0 && StopLoss == 0)OpenOrders();
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
   string errors(int error){
     string error_string;
     switch(error){
         case 0:   error_string=" OK";                                      break;
         case 1:   error_string="  ";                    break;
         case 2:   error_string="  ";                            break;
         case 3:   error_string="  ";                  break;
         case 4:   error_string="   ";                   break;
         case 5:   error_string="   ";                 break;
         case 6:   error_string="     ";           break;
         case 7:   error_string="  ";                       break;
         case 8:   error_string="   ";                  break;
         case 9:   error_string="  ";                   break;
         case 64:  error_string="  ";                       break;
         case 65:  error_string="   ";                break;
         case 128: error_string="   ";                  break;
         case 129: error_string="  ";                       break;
         case 130: error_string="  , SL  ";            break;
         case 131: error_string="  ";                      break;
         case 132: error_string="  ";                            break;
         case 133: error_string="  ";                      break;
         case 134: error_string="  ";                    break;
         case 135: error_string="  ";                         break;
         case 136: error_string="  ";                                 break;
         case 137: error_string="  ";                            break;
         case 138: error_string="  ";                              break;
         case 139: error_string="  ";                    break;
         case 140: error_string="   ";                break;
         case 141: error_string="   ";                  break;
         case 145: error_string="     ";            break;
         case 146: error_string="   ";              break;
         case 147: error_string="    ";          break;
         case 148: error_string="   ";           break;
         case 149: error_string="  ";                  break;
         case 150: error_string="   FIFO";                   break;
         default:  error_string="   ";                    break;
     }
     return (error_string);
  }
//+------------------------------------------------------------------+